/* Botanical_Better follows the much more sophisticated L-System where there is a bit of randomness
introduced to the rules. It still follows the basic LSystem structure where it iterates an axiom based 
on some rules. So the Code is very similar. However it looks for popping and pushing characters as well 
as a forward and branch character. These all placed together can make Beautiful Trees and branches.
See lsystem for commented code on basic structure changes will be commented here only. 
*/
class Botanical_Better{
 String axiom;
 String computedWord;
 //String[][] sqRules = {{"F", "F-F-F-F+"}};
 String[][] rules = {{"X", "F[-XFX][+XFX]","F[-X][+FX]","F[-XFX][+XFX"},{"F","F","FF","FF"},{"+","+","+","+"},{"-","-","-","-"},
{"[", "[","[","["}, {"]","]","]","]"},};
 float size, angle;
 
Botanical_Better(float size, float angle){
   this.size = size;
   this.angle = angle;
   //a bit of a complicated axiom but I had a distint design I wanted for the basic shape.
   axiom = "F[+FFX]F[-X][FX]FFXFX";
   computedWord = axiom;
   
}

void iterate(int iterations){
 String tempWord;
 //println(computedWord);
 tempWord = computedWord;
 for(int i = 0; i < iterations; i++){
   tempWord = computedWord;
   computedWord = "";
   for(int j = 0; j <tempWord.length(); j++){
      char c = tempWord.charAt(j);
      for(int k = 0; k < rules.length; k++){
       if( c == rules[k][0].charAt(0)){
            computedWord = computedWord + rules[k][(int)random(1,3)];
            break;
       }
      }
   }
  // println("itearation" + i + ":" + computedWord);
 }
    println(computedWord);
}


void drawLSystem(Turtle t){
  // move the turtle down as the shape will move grow up.
  t.penUp();
  t.back(height/2 - 10);
  t.penDown();
 for(int i = 0; i <computedWord.length(); i++){
   char c = computedWord.charAt(i);
  if(c == 'F')
   t.forward(size); 
   else if(c == 'L')
   t.forward(size);
   else if(c == 'R')
   t.forward(size);
   else if(c == '+')
    t.right(angle);
   else if(c == '-')
    t.left(angle);
   else if(c == '[')
     t.push();
   else if(c == ']')
     t.pop();
   else if(c == 'X')
   // can create berries if wanted. Not really used in the final portion. 
     fill(255,0,0);
     noStroke();
     //ellipse(t.getX(),t.getY(),2,2);
     stroke(0);
     noFill();
     
 }
}

}
